# This file was created automatically by SWIG.
import subproblemc
from oof2.SWIG.engine.femesh import FEMeshPtr
class SubProblemPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def set_freedofmap(self, *_args, **_kwargs):
        val = apply(subproblemc.SubProblem_set_freedofmap,(self,) + _args, _kwargs)
        return val
    def __del__(self,subproblemc=subproblemc):
        if self.thisown == 1 :
            subproblemc.delete_SubProblem(self)
    def __repr__(self):
        return "<C SubProblem instance at %s>" % (self.this,)
class SubProblem(SubProblemPtr):
    def __init__(self,this):
        self.this = this






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: subproblem_.py,v $
# $Revision: 1.4 $
# $Author: redwing $
# $Date: 2005/06/16 16:14:18 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

import oof2.engine.mesh
from oof2.common.IO import whoville

def __init(self, name):
    self.name = name
    self.active_fields = {}
    self.active_equations = {}
    self.active_kinetics = {}
    self.active_dynamics = {}
    self.matrixdriver = None
    self.timedriver = None
    self.active_region = None
SubProblemPtr.__init__ = __init

## Equations
def __addEquation(self, equation):
    self.active_equations[equation.name()] = equation
SubProblemPtr.addEquation = __addEquation

def __deleteEquation(self, equation):
    try:
        del self.active_equations[equation.name()]
    except KeyError:
        pass
SubProblemPtr.deleteEquation = __deleteEquation
## Fields
def __addField(self, field):
    self.active_fields[field.name()] = field
SubProblemPtr.addField = __addField

def __deleteField(self, field):
    try:
        del self.active_fields[field.name()]
    except KeyError:
        pass
SubProblemPtr.deleteField = __deleteField
## Active region name
def __setActiveRegion(self, skeleton, group):
    self.active_region = (skeleton, group)
SubProblemPtr.setActiveRegion = __setActiveRegion

def __getActiveRegion(self):
    return self.active_region
SubProblemPtr.getActiveRegion = __getActiveRegion
## Activate kinetics
def __activateKinetics(self, equation):
    self.active_kinetics[equation.name()] = equation
SubProblemPtr.activateKinetics = __activateKinetics
def __deactivateKinetics(self, equation):
    del self.active_kinetics[equation.name()]
SubProblemPtr.deactivateKinetics = __deactivateKinetics
## Activate dynamics
def __activateDynamics(self, equation):
    self.active_dynamics[equation.name] = equation
SubProblemPtr.activateDynamics = __activateDynamics
def __deactivateDynamics(self, equation):
    del self.active_dynamics[equation.name()]
SubProblemPtr.deactivateDynamics = __deactivateDynamics
def __setMatrixDriver(self, matrixdriver):
    self.matrixdriver = matrixdriver
SubProblemPtr.setMatrixDriver = __setMatrixDriver
def __setTimeDriver(self, timedriver):
    self.timedriver = timedriver
SubProblemPtr.setTimeDriver = __setTimeDriver


##
##
## METHODS FOR SOLVING SUBMESHES START HERE
##
##
##

def __precompute(self, mesh): ## mesh is the colon separated mesh name
    meshcontext = oof2.engine.mesh.meshes[mesh]
    femesh =  meshcontext.femesh()
    ## activate equations the *official* way.
    for eqn in femesh.all_equations():
        if eqn.name() in self.active_equations:
            femesh.activate_equation(equation)
            switchboard.notify('equation activated', mesh, eqn.name(), 1)
            if eqn.name() in self.active_kinetics:
                femesh.kinetic_activate_equation(equation)
                switchboard.notify('kinetics activated', mesh, eqn.name(), 1)
            if eqn.name() in self.active_dynamics:
                femesh.activate_dynamics(equation)
                switchboard.notify('dynamics activated', mesh, eqn.name(), 1)
            
    ## activate fields, also the *official* way.
    for fld in femesh.all_fields():
        if fld.name() in self.active_fields:
            femesh.deactivate_field(field)
            switchboard.notify("field activated", mesh, fld.name(), 1)
    ## select active region
    ## elements and DOFs are set to be unsubmeshable
    skelname, group = meshcontext.getActiveRegion()
    skelc = whoville.getClass('Skeleton')[skelname]
    members = skelc.elementgroups.get_group(group)
    for skel_el in members:
        element = self.mesh.getElement(skel_el.meshindex)
        element.setsubmesh()
SubProblemPtr.precompute = __precompute

def __apply(self, mesh): ## for non-interacting 
    meshcontext = oof2.engine.mesh.meshes[mesh]
    femesh =  meshcontext.femesh()
    self.timedriver.apply_one_step(self.matrixdriver, meshcontext) ## DOES NOT UPDATE TIME INDEX
SubProblemPtr.apply = __apply

def __postcompute(self, mesh):
    meshcontext = oof2.engine.mesh.meshes[mesh]
    femesh =  meshcontext.femesh()
    self.set_freedofmap(femesh) ## will be used to accept/reject solution
SubProblemPtr.postcompute = __postcompute

##
##
## METHODS FOR SOLVING SUBMESHES END HERE
##
##
##
