// -*- C++ -*-
// $RCSfile: activearea.h,v $
// $Revision: 1.2 $
// $Author: langer $
// $Date: 2004/11/29 20:18:48 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>

#ifndef ACTIVEAREA_H
#define ACTIVEAREA_H

#include "common/cpixelselection.h"

class ActiveArea : public CPixelSelection {
  bool override_;
public:
  ActiveArea(const ICoord *pxlsize, const Coord *size,
	      CMicrostructure *ms)
    : CPixelSelection(pxlsize, size, ms), override_(false)
  {}
  ActiveArea *clone() const { return new ActiveArea(*this); }
  bool isActive(const ICoord *pxl) const {
    return override_ || !isSelected(pxl);
  }
  bool isActive(const ICoord &pxl) const {
    return override_ || !isSelected(&pxl);
  }
  void override(bool val) { 
    override_ = val; }
  bool getOverride() const { return override_; }

// This function doesn't exist, because PixelGroup::nonmembers()
// doesn't exist.  It would be an expensive function to compute, so
// it's probably better to avoid needing a list of active pixels.
//
//   const std::vector<ICoord> *activePixels() const {
//     return getPixelGroup()->nonmembers();
//   }

};

#endif // ACTIVEAREA_H
