# -*- python -*-
# $RCSfile: excepthook.py,v $
# $Revision: 1.6 $
# $Author: langer $
# $Date: 2005/05/13 18:43:45 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# A module for managing the Python exception hook.

import sys, traceback
from oof2.common import debug

def _printTraceBack(e_type, e_value, tblist):
    for line in traceback.format_exception_only(e_type, e_value):
        print line,
    for line in traceback.format_list(tblist):
        print line,

def _OOFexceptHook(e_type, e_value, tback):
    tblist = traceback.extract_tb(tback)
    if debug.debug():
        _printTraceBack(e_type, e_value, tblist)
    printTraceBack(e_type, e_value, tblist)

printTraceBack = _printTraceBack
## sys.excepthook = _OOFexceptHook

##old_excepthook = sys.excepthook

### Should be called zero or one times.
def assign_excepthook(new_excepthook):
    global old_excepthook
    old_excepthook = sys.excepthook
    sys.excepthook = new_excepthook

def restore_excepthook():
    global old_excepthook
    sys.excepthook = old_excepthook

assign_excepthook(_OOFexceptHook)
