# -*- python -*-
# $RCSfile: petsc_solver_.py,v $
# $Revision: 1.11 $
# $Author: langer $
# $Date: 2005/05/13 18:44:13 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from oof2.common import cregisteredclass
from oof2.common.IO import parameter
from oof2.SWIG.engine import solver

from oof2.SWIG.engine.PETSc.petsc_preconditioner import PETScPreconditionerWrapPtr

cregisteredclass.Registration("PETScGMRES", solver.SolverPtr,
                              PETScGMRESSolver, ordering=3100,
                                                   params=[
    parameter.IntParameter("max_iterations", 1000),
    parameter.FloatParameter("tolerance", 1e-8),
    parameter.FloatParameter("arlb", 1e-50),
    parameter.FloatParameter("arub", 1e50),
    parameter.RegisteredParameter("pc", PETScPreconditionerWrapPtr)
    ]
                                                   )

cregisteredclass.Registration("PETScBiCG", solver.SolverPtr,
                              PETScBiCGSolver, ordering=3200,
                             params=[
    parameter.IntParameter("max_iterations", 1000),
    parameter.FloatParameter("tolerance", 1e-8),
    parameter.FloatParameter("arlb", 1e-50),
    parameter.FloatParameter("arub", 1e50),
    parameter.RegisteredParameter("pc", PETScPreconditionerWrapPtr)
    ]
                             )

cregisteredclass.Registration("PETScRichardson", solver.SolverPtr,
                              PETScRichardsonSolver, ordering=3300,
                             params=[
    parameter.IntParameter("max_iterations", 1000),
    parameter.FloatParameter("tolerance", 1e-8),
    parameter.FloatParameter("arlb", 1e-50),
    parameter.FloatParameter("arub", 1e50),
    parameter.RegisteredParameter("pc", PETScPreconditionerWrapPtr)
    ]
                             )

cregisteredclass.Registration("PETScChebychev", solver.SolverPtr,
                              PETScChebychevSolver, ordering=3400,
                             params=[
    parameter.IntParameter("max_iterations", 1000),
    parameter.FloatParameter("tolerance", 1e-8),
    parameter.FloatParameter("arlb", 1e-50),
    parameter.FloatParameter("arub", 1e50),
    parameter.RegisteredParameter("pc", PETScPreconditionerWrapPtr)
    ]
                             )


cregisteredclass.Registration("PETScCG", solver.SolverPtr,
                              PETScCGSolver, ordering=3500,
                             params=[
    parameter.IntParameter("max_iterations", 1000),
    parameter.FloatParameter("tolerance", 1e-8),
    parameter.FloatParameter("arlb", 1e-50),
    parameter.FloatParameter("arub", 1e50),
    parameter.RegisteredParameter("pc", PETScPreconditionerWrapPtr)
    ]
                             )



cregisteredclass.Registration("PETScBiCGStab", solver.SolverPtr,
                              PETScBiCGStabSolver, ordering=3600,
                             params=[
    parameter.IntParameter("max_iterations", 1000),
    parameter.FloatParameter("tolerance", 1e-8),
    parameter.FloatParameter("arlb", 1e-50),
    parameter.FloatParameter("arub", 1e50),
    parameter.RegisteredParameter("pc", PETScPreconditionerWrapPtr)
    ]
                             )

cregisteredclass.Registration("PETScCGSquared", solver.SolverPtr,
                              PETScCGSquaredSolver, ordering=3600,
                             params=[
    parameter.IntParameter("max_iterations", 1000),
    parameter.FloatParameter("tolerance", 1e-8),
    parameter.FloatParameter("arlb", 1e-50),
    parameter.FloatParameter("arub", 1e50),
    parameter.RegisteredParameter("pc", PETScPreconditionerWrapPtr)
    ]
                             )



cregisteredclass.Registration("PETScTFQMR1", solver.SolverPtr,
                              PETScTFQMR1Solver, ordering=3700,
                             params=[
    parameter.IntParameter("max_iterations", 1000),
    parameter.FloatParameter("tolerance", 1e-8),
    parameter.FloatParameter("arlb", 1e-50),
    parameter.FloatParameter("arub", 1e50),
    parameter.RegisteredParameter("pc", PETScPreconditionerWrapPtr)
    ]
                             )


cregisteredclass.Registration("PETScTFQMR2", solver.SolverPtr,
                              PETScTFQMR2Solver, ordering=3800,
                             params=[
    parameter.IntParameter("max_iterations", 1000),
    parameter.FloatParameter("tolerance", 1e-8),
    parameter.FloatParameter("arlb", 1e-50),
    parameter.FloatParameter("arub", 1e50),
    parameter.RegisteredParameter("pc", PETScPreconditionerWrapPtr)
    ]
                             )


cregisteredclass.Registration("PETScCR", solver.SolverPtr,
                              PETScCRSolver, ordering=3900,
                             params=[
    parameter.IntParameter("max_iterations", 1000),
    parameter.FloatParameter("tolerance", 1e-8),
    parameter.FloatParameter("arlb", 1e-50),
    parameter.FloatParameter("arub", 1e50),
    parameter.RegisteredParameter("pc", PETScPreconditionerWrapPtr)
    ]
                             )

cregisteredclass.Registration("PETScLeastSquares", solver.SolverPtr,
                              PETScLeastSquaresSolver, ordering=4000,
                             params=[
    parameter.IntParameter("max_iterations", 1000),
    parameter.FloatParameter("tolerance", 1e-8),
    parameter.FloatParameter("arlb", 1e-50),
    parameter.FloatParameter("arub", 1e50),
    parameter.RegisteredParameter("pc", PETScPreconditionerWrapPtr)
    ]
                             )


