# -*- python -*-
# $RCSfile: flux_.py,v $
# $Revision: 1.12 $
# $Author: langer $
# $Date: 2005/05/13 18:44:05 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

import types
from oof2.common import debug
from oof2.common import utils
from oof2.engine import component

FluxPtr.__repr__ = FluxPtr.name
SymmetricTensorFluxPtr.__repr__ = SymmetricTensorFluxPtr.name
VectorFluxPtr.__repr__ = VectorFluxPtr.name

def _Flux___hash__(self):
    return self.objectid()

FluxPtr.__hash__ = _Flux___hash__

def _Flux___cmp__(self, other):
    if not isinstance(other, FluxPtr): return -1
    if self.objectid() < other.objectid(): return -1
    if self.objectid() > other.objectid(): return 1
    return 0

FluxPtr.__cmp__ = _Flux___cmp__

class _AllFluxes:
    def __getitem__(self, indx):
        if type(indx) == types.IntType:
            if indx >= countFluxes():
                raise IndexError("Bad flux index: " + str(indx))
            return getFluxByIndex(indx)
        elif type(indx) == types.StringType:
            try:
                flx = utils.OOFeval(indx)
            except NameError:
                raise IndexError("Bad flux name: " + indx)
            if not isinstance(flx, FluxPtr):
                raise IndexError("Bad flux name: " + indx)
            return flx
##            for i in range(countFluxes()):
##                f = getFluxByIndex(i)
##                if f.name() == indx:
##                    return f
##            raise IndexError("Bad flux name: " + indx)
    def __len__(self):
        return countFluxes()

allFluxes = _AllFluxes()

def getFlux(which):
    return allFluxes[which]

utils.OOFdefine('getFlux', getFlux)

def _Flux___getitem__(self, comp):
    # deFortranify
    if type(comp) is types.TupleType:
        c = [x-1 for x in comp]
    else:
        c = [comp-1]
    return component.Component(self, c)

FluxPtr.__getitem__ = _Flux___getitem__
