// -*- C++ -*-
// $RCSfile: nodalscpatches.C,v $
// $Revision: 1.2 $
// $Author: haan $
// $Date: 2005/04/22 18:40:22 $


/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>
#include <iostream>
#include <map>

#include "engine/cscpatch.h"
#include "engine/nodalscpatches.h"


NodalSCPatches::~NodalSCPatches()
{
  // deleting new'd CSCPatches
  for(int i=0; i<scpatches.size(); i++)
    delete scpatches[i];
}

//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//

void NodalSCPatches::add_patch(CSCPatch *patch)
{
  scpatches.push_back(patch);
}

//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//

std::vector<int> *NodalSCPatches::get_elements_from_patch(const Material *mat)
{
  for(int i=0; i<scpatches.size(); i++)
    if(scpatches[i]->material() == mat)
      return scpatches[i]->get_elements();
}

std::vector<int> *NodalSCPatches::get_nodes_from_patch(const Material *mat)
{
  for(int i=0; i<scpatches.size(); i++)
    if(scpatches[i]->material() == mat)
      return scpatches[i]->get_nodes();
}

//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//

void NodalSCPatches::recover_fluxes(const std::vector<Flux*> &allfluxes)
{
  for(int i=0; i<scpatches.size(); i++)
    scpatches[i]->recover_fluxes(allfluxes);
}
