# -*- python -*-
# $RCSfile: thermo_.py,v $
# $Revision: 1.25 $
# $Author: langer $
# $Date: 2005/05/13 18:44:15 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov.

from oof2.engine import propertyregistration
PropertyRegistration = propertyregistration.PropertyRegistration

from oof2.common.IO import parameter
FloatParameter = parameter.FloatParameter

from oof2.engine.IO import isocijkl 
from oof2.engine import problem
from oof2.SWIG.common import devel
import types

if devel.devel():
    PropertyRegistration(
        'Mechanical:Elasticity:ThermoElasticity', ThermoElasticityProp,
        "oof2.SWIG.engine.property.elasticity.thermo.thermo",100,
        [isocijkl.IsotropicRank4TensorParameter('cijkl',
                        isocijkl.IsotropicRank4TensorLame(lmbda=1.0, mu=0.5),
                                                tip=parameter.emptyTipString),
         FloatParameter('t0', 0.0, tip=parameter.emptyTipString),
         FloatParameter('alpha', 0.0, tip=parameter.emptyTipString)],
        fields=[problem.Temperature, problem.Displacement],
        fluxes=[problem.Stress],
        outputs=["Energy"],
        propertyType="Elasticity")
    

# Repr refers to registration name, not actual class name.
def _ThermoElasticity___repr__(self):
    return "ThermoElasticity(name='%s', cjikl=%s, t0=%s, alpha=%s)" % \
           (self.name(), `self.cijkl_param()`,
            `self.t0()`, `self.dmudt()`)

ThermoElasticityPropPtr.__repr__ = _ThermoElasticity___repr__

# Ought to be possible to use the instance's conversion machine?
# Or some other more general interface.
def _ThermoElasticity_cijkl_param(self):
    cijkl = self.cijkl_pointer()
    c11 = cijkl[0,0]
    c12 = cijkl[0,1]
    return isocijkl.IsotropicRank4TensorLame(lmbda=c12, mu=(c11-c12)/2.0)

ThermoElasticityPropPtr.cijkl_param = _ThermoElasticity_cijkl_param
