// -*- C++ -*-
// $RCSfile: heatcapacity.h,v $
// $Revision: 1.4 $
// $Author: langer $
// $Date: 2005/06/15 21:14:37 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#ifndef HEATCAPACITY_H
#define HEATCAPACITY_H

#include "engine/property.h"
#include <string>

class Cijkl;
class Element;
class Flux;
class Material;
class FEMesh;
class ScalarField;
class VectorFlux;
class Position;
class ElementNodeIterator;

class HeatCapacity : public ScalarTimeDerivPrefactor {
public:
  HeatCapacity(PyObject *reg, const std::string &name, double cp);
  virtual ~HeatCapacity() {}
  virtual int K_integration_order(int) const;
  virtual int is_symmetric(const FEMesh*) const {return 1;}
  virtual double fetch_value() const {return 1./generic_property_param;} 
protected:
  ScalarField *temperature;
  VectorFlux *heat_flux;
};

#endif
