# -*- python -*-
# $RCSfile: sparselink_.py,v $
# $Revision: 1.3 $
# $Author: langer $
# $Date: 2005/04/21 19:13:29 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

def _SparseLinkMat___setitem__(self, idx, val):
    self.set(idx[0], idx[1], val)

SparseLinkMat.__setitem__ = _SparseLinkMat___setitem__

def _SparseLinkMat___getitem__(self, idx):
    return self.get(idx[0], idx[1])

SparseLinkMat.__getitem__ = _SparseLinkMat___getitem__

#################

## Code for iterating over the non-zero entries of a SparseLinkMat.
## This is sort of ugly, and could be done much better with modern
## Python iterators and yield statements.  However, it's just here for
## debugging purposes.

def _SparseLinkMat_iterator(self, row=None):
    if row is None:
        return SparseLinkMatIterator(self)
    return SparseLinkMatRowIterator(self, row)

SparseLinkMatPtr.iterator = _SparseLinkMat_iterator

class SparseLinkMatIterator:
    def __init__(self, slm):
        self.slm = slm
        self.iter = slm.begin()
        self.end = slm.end()
    def __getitem__(self, dummy):
        if(not self.iter.lessthan(self.end)):
            raise IndexError
        ans = (self.iter.row(), self.iter.col(), self.iter.value())
        self.iter.next()
        return ans

class SparseLinkMatRowIterator(SparseLinkMatIterator):
    def __init__(self, slm, row):
        self.slm = slm
        self.iter = slm.beginrow(row)
        self.end = slm.endrow(row)

##################

def _structure(self):
    # make an array of dashes
    structure = [[ '-' for i in range(self.ncols()) ] + ['\n']
                 for j in range(self.nrows()) ]
    # replace dashes by 'X's for each non-zero entry in the matrix
    for ij in self.iterator():
        structure[ij[0]][ij[1]] = 'X'
    # join each line into a string, without spaces between characters,
    # and prepend the line number
    structure = ["%3d "%i + string.join(structure[i], '')
                 for i in range(self.nrows())]

    header = "    " + ('0123456789'*(self.ncols()/10 + 1))[:self.ncols()] + '\n'
    return header + string.join(structure, '')

SparseLinkMatPtr.structure = _structure
