// -*- C++ -*-
// $RCSfile: timestepadaptermanager.C,v $
// $Revision: 1.1 $
// $Author: redwing $
// $Date: 2005/06/14 20:02:43 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>

#include "engine/timestepadaptermanager.h"
#include "engine/femesh.h"
#include "engine/subproblem.h"
#include "engine/steppingscheme.h"

void TimeStepAdapterManager::accept(FEMesh *femesh, SubProblem *smesh, SteppingScheme * smethod)
{
  femesh->set_unknowns(*smethod->get_x(), *smesh->get_freedofmap());
  smesh->set_prev_solution(smethod->get_x());//will allocate memory if null
}

void TimeStepAdapterManager::reject(FEMesh *femesh, SubProblem *smesh)
{
  femesh->set_unknowns(*smesh->get_prev_solution(), *smesh->get_freedofmap());
  
}
