// -*- C++ -*-
// $RCSfile: twomatrix.h,v $
// $Revision: 1.2 $
// $Author: reida $
// $Date: 2003/04/02 14:52:39 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>

#ifndef TWOMATRIX_H
#define TWOMATRIX_H

// Fast two by two matrix class.

class TwoMatrix {
public:
  TwoMatrix()
    : xx(0.), xy(0.), yx(0.), yy(0.)
  {}
  TwoMatrix(double xx, double xy, double yx, double yy)
    : xx(xx), xy(xy), yx(yx), yy(yy)
  {}
  double xx, xy, yx, yy;
  double conditionNumber() const;
  TwoMatrix inverse() const;
  double norm2() const;
};

#endif // TWOMATRIX_H
